Index: palm/trunk/SOURCE/Makefile
===================================================================
--- palm/trunk/SOURCE/Makefile	(revision 2934)
+++ palm/trunk/SOURCE/Makefile	(revision 2938)
@@ -25,4 +25,9 @@
 # -----------------
 # $Id$
+# No initialization of child domains via dynamic input file, except for soil
+# moisture and temperature
+# Apply turbulence generator at non-cyclic lateral boundary in nesting case
+# 
+# 2936 2018-03-27 14:49:27Z suehring
 # Added dependencies for parent and child synchronization
 # 
@@ -1008,4 +1013,5 @@
 	modules.o \
 	netcdf_data_input_mod.o \
+	pmc_interface_mod.o \
 	radiation_model_mod.o \
 	surface_mod.o
@@ -1434,5 +1440,6 @@
 	cpulog_mod.o \
 	mod_kinds.o \
-	modules.o
+	modules.o \
+	pmc_interface_mod.o
 temperton_fft_mod.o: \
 	mod_kinds.o \
@@ -1510,4 +1517,5 @@
 	modules.o \
 	plant_canopy_model_mod.o \
+	pmc_interface_mod.o \
 	surface_mod.o \
 	user_actions.o
Index: palm/trunk/SOURCE/boundary_conds.f90
===================================================================
--- palm/trunk/SOURCE/boundary_conds.f90	(revision 2934)
+++ palm/trunk/SOURCE/boundary_conds.f90	(revision 2938)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Set boundary condition for TKE and TKE dissipation rate in case of nesting
+! and if parent model operates in RANS mode but child model in LES mode.
+! mode
+! 
+! 2793 2018-02-07 10:54:33Z suehring
 ! Removed preprocessor directive __chem
 ! 
@@ -193,7 +198,7 @@
                inflow_s, intermediate_timestep_count,                          &
                microphysics_morrison, microphysics_seifert, nest_domain,       &
-               nest_bound_l, nest_bound_s, nudging, ocean, outflow_l,          &
-               outflow_n, outflow_r, outflow_s, passive_scalar, rans_tke_e,    &
-               tsc, use_cmax
+               nest_bound_l, nest_bound_n, nest_bound_r, nest_bound_s, nudging,&
+               ocean, outflow_l, outflow_n, outflow_r, outflow_s,              &
+               passive_scalar, rans_mode, rans_tke_e, tsc, use_cmax
 
     USE grid_variables,                                                        &
@@ -209,5 +214,5 @@
 
     USE pmc_interface,                                                         &
-        ONLY : nesting_mode
+        ONLY : nesting_mode, rans_mode_parent
 
     USE surface_mod,                                                           &
@@ -321,6 +326,6 @@
 
 !
-!-- Boundary conditions for TKE
-!-- Generally Neumann conditions with de/dz=0 are assumed
+!-- Boundary conditions for TKE.
+!-- Generally Neumann conditions with de/dz=0 are assumed.
     IF ( .NOT. constant_diffusion )  THEN
 
@@ -343,9 +348,28 @@
        IF ( .NOT. nest_domain )  THEN
           e_p(nzt+1,:,:) = e_p(nzt,:,:)
-       ENDIF
-    ENDIF
-
-!
-!-- Boundary conditions for TKE dissipation rate
+!
+!--    Nesting case: if parent operates in RANS mode and child in LES mode,
+!--    no TKE is transfered. This case, set Neumann conditions at lateral and 
+!--    top child boundaries. 
+!--    If not ( both either in RANS or in LES mode ), TKE boundary condition
+!--    is treated in the nesting. 
+       ELSE
+
+          IF ( rans_mode_parent  .AND.  .NOT. rans_mode )  THEN
+
+
+
+             e_p(nzt+1,:,:) = e_p(nzt,:,:)
+             IF ( nest_bound_l )  e_p(:,:,nxl-1) = e_p(:,:,nxl)
+             IF ( nest_bound_r )  e_p(:,:,nxr+1) = e_p(:,:,nxr)
+             IF ( nest_bound_s )  e_p(:,nys-1,:) = e_p(:,nys,:)
+             IF ( nest_bound_n )  e_p(:,nyn+1,:) = e_p(:,nyn,:)
+
+          ENDIF
+       ENDIF
+    ENDIF
+
+!
+!-- Boundary conditions for TKE dissipation rate. 
     IF ( rans_tke_e .AND. .NOT. nest_domain )  THEN
        diss_p(nzt+1,:,:) = diss_p(nzt,:,:)
Index: palm/trunk/SOURCE/check_parameters.f90
===================================================================
--- palm/trunk/SOURCE/check_parameters.f90	(revision 2934)
+++ palm/trunk/SOURCE/check_parameters.f90	(revision 2938)
@@ -25,4 +25,10 @@
 ! -----------------
 ! $Id$
+! - Revise start and end indices for imposing random disturbances in case of
+!   nesting or large-scale forcing.
+! - Remove check for inifor initialization in case of nested runs. 
+! - Adapt call to check for synthetic turbulence geneartor settings.
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! Check spinup in case of nested runs, spinup time and timestep must be 
 ! identical to assure synchronuous simulations. 
@@ -1382,26 +1388,4 @@
     ENDIF
 !
-!-- In case of nested run assure that all domains are initialized the same
-!-- way, i.e. if at least at one domain is initialized with soil and 
-!-- atmospheric data provided by COSMO, all domains must be initialized the 
-!-- same way, to assure that soil and atmospheric quantities are 
-!-- consistent. 
-    IF ( nested_run )  THEN
-       check_nest = .TRUE.
-#if defined( __parallel )
-       CALL MPI_ALLREDUCE( TRIM( initializing_actions ) == 'inifor',           &
-                           check_nest, 1, MPI_LOGICAL,                         &
-                           MPI_LAND, MPI_COMM_WORLD, ierr )
-
-       IF ( TRIM( initializing_actions ) == 'inifor'  .AND.                    &
-            .NOT.  check_nest )  THEN
-          message_string = 'In case of nesting, if at least in one ' //        &
-                           'domain initializing_actions = inifor, '  //        &
-                           'all domains need to be initialized that way.'
-          CALL message( 'netcdf_data_input_mod', 'PA0430', 3, 2, 0, 6, 0 )
-       ENDIF
-#endif
-    ENDIF
-!
 !-- In case of spinup and nested run, spinup end time must be identical 
 !-- in order to have synchronously running simulations. 
@@ -1436,6 +1420,6 @@
 
 !
-!-- When synthetic turbulence generator is used, peform addtional checks
-    IF ( syn_turb_gen )  CALL stg_check_parameters
+!-- Check for synthetic turbulence generator settings
+    CALL stg_check_parameters
 !
 !-- When plant canopy model is used, peform addtional checks
@@ -3898,5 +3882,6 @@
           dist_nxr(1) = MIN( inflow_disturbance_end, nxr )
        ELSEIF ( bc_lr == 'nested'  .OR.  bc_lr == 'forcing' )  THEN
-          dist_nxl = MAX( inflow_disturbance_begin, nxl )
+          dist_nxl    = MAX( inflow_disturbance_begin, nxl )
+          dist_nxr    = MIN( nx - inflow_disturbance_begin, nxr )
        ENDIF
        IF ( bc_ns == 'dirichlet/radiation' )  THEN
@@ -3907,5 +3892,6 @@
           dist_nyn(1) = MIN( inflow_disturbance_end, nyn )
        ELSEIF ( bc_ns == 'nested'  .OR.  bc_ns == 'forcing' )  THEN
-          dist_nys = MAX( inflow_disturbance_begin, nys )
+          dist_nys    = MAX( inflow_disturbance_begin, nys )
+          dist_nyn    = MIN( ny - inflow_disturbance_begin, nyn )
        ENDIF
     ELSE
@@ -3918,4 +3904,7 @@
           dist_nxl    = inflow_disturbance_begin
           dist_nxr(1) = inflow_disturbance_end
+       ELSEIF ( bc_lr == 'nested'  .OR.  bc_lr == 'forcing' )  THEN
+          dist_nxr    = nx - inflow_disturbance_begin
+          dist_nxl    = inflow_disturbance_begin
        ENDIF
        IF ( bc_ns == 'dirichlet/radiation' )  THEN
@@ -3925,4 +3914,7 @@
           dist_nys    = inflow_disturbance_begin
           dist_nyn(1) = inflow_disturbance_end
+       ELSEIF ( bc_ns == 'nested'  .OR.  bc_ns == 'forcing' )  THEN
+          dist_nyn    = ny - inflow_disturbance_begin
+          dist_nys    = inflow_disturbance_begin
        ENDIF
     ENDIF
Index: palm/trunk/SOURCE/init_3d_model.f90
===================================================================
--- palm/trunk/SOURCE/init_3d_model.f90	(revision 2934)
+++ palm/trunk/SOURCE/init_3d_model.f90	(revision 2938)
@@ -25,4 +25,8 @@
 ! -----------------
 ! $Id$
+! - Revise Inifor initialization for geostrophic wind components
+! - Initialize synthetic turbulence generator in case of Inifor initialization  
+!
+! 2936 2018-03-27 14:49:27Z suehring
 ! Synchronize parent and child models after initialization.
 ! Remove obsolete masking of topography grid points for Runge-Kutta weighted
@@ -1189,6 +1193,14 @@
 !--           are not identical to the initial wind profiles in this case. 
 !--           This need to be further revised.
-!           ug(:) = u_init(:)
-!           vg(:) = v_init(:)
+          IF ( init_3d%from_file_ug )  THEN
+             ug(:) = init_3d%ug_init(:)
+          ENDIF
+          IF ( init_3d%from_file_vg )  THEN
+             vg(:) = init_3d%vg_init(:)
+          ENDIF
+
+          ug(nzt+1) = ug(nzt)
+          vg(nzt+1) = vg(nzt)
+
 !
 !--       Set inital w to 0
@@ -1243,4 +1255,7 @@
 !--       fluxes, etc. 
           CALL init_surfaces
+!
+!--       Initialize turbulence generator
+          IF( use_syn_turb_gen )  CALL stg_init
 
           CALL location_message( 'finished', .TRUE. )
@@ -1335,7 +1350,5 @@
 !
 !--       Overwrite initial profiles in case of synthetic turbulence generator
-          IF( use_syn_turb_gen ) THEN
-             CALL stg_init
-          ENDIF
+          IF( use_syn_turb_gen )  CALL stg_init
 
 !
Index: palm/trunk/SOURCE/init_pegrid.f90
===================================================================
--- palm/trunk/SOURCE/init_pegrid.f90	(revision 2934)
+++ palm/trunk/SOURCE/init_pegrid.f90	(revision 2938)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! - No checks for domain decomposition in case of turbulence generator 
+!  (is done in stg module)
+! - Introduce ids to indicate lateral processors for turbulence generator
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! Variable use_synthetic_turbulence_generator has been abbreviated
 ! 
@@ -251,5 +256,6 @@
 
     USE synthetic_turbulence_generator_mod,                                    &
-        ONLY:  use_syn_turb_gen
+        ONLY:  id_stg_left, id_stg_north, id_stg_right, id_stg_south,          &
+               use_syn_turb_gen
 
     USE transpose_indices,                                                     &
@@ -267,4 +273,8 @@
     INTEGER(iwp) ::  id_outflow_source_l      !< local value of id_outflow_source
     INTEGER(iwp) ::  id_recycling_l           !<
+    INTEGER(iwp) ::  id_stg_left_l            !< left lateral boundary local core id in case of turbulence generator  
+    INTEGER(iwp) ::  id_stg_north_l           !< north lateral boundary local core id in case of turbulence generator  
+    INTEGER(iwp) ::  id_stg_right_l           !< right lateral boundary local core id in case of turbulence generator  
+    INTEGER(iwp) ::  id_stg_south_l           !< south lateral boundary local core id in case of turbulence generator  
     INTEGER(iwp) ::  ind(5)                   !<
     INTEGER(iwp) ::  j                        !<
@@ -518,6 +528,5 @@
 !-- 1. transposition  z --> x
 !-- This transposition is not neccessary in case of a 1d-decomposition along x
-    IF ( psolver == 'poisfft'  .OR.  calculate_spectra  .OR.                   &
-         use_syn_turb_gen )  THEN
+    IF ( psolver == 'poisfft'  .OR.  calculate_spectra )  THEN
 
        IF ( pdims(2) /= 1 )  THEN
@@ -1263,5 +1272,48 @@
        ENDIF
     ENDIF
-
+!
+!-- In case of synthetic turbulence geneartor determine ids. 
+!-- Please note, if no forcing or nesting is applied, the generator is applied
+!-- only at the left lateral boundary.
+    IF ( use_syn_turb_gen )  THEN
+       IF ( force_bound_l  .OR.  nest_bound_l  .OR.  inflow_l )  THEN
+          id_stg_left_l = myidx
+       ELSE
+          id_stg_left_l = 0
+       ENDIF
+       IF ( force_bound_r  .OR.  nest_bound_r )  THEN
+          id_stg_right_l = myidx
+       ELSE
+          id_stg_right_l = 0
+       ENDIF
+       IF ( force_bound_s  .OR.  nest_bound_s )  THEN
+          id_stg_south_l = myidy
+       ELSE
+          id_stg_south_l = 0
+       ENDIF
+       IF ( force_bound_n  .OR.  nest_bound_n )  THEN
+          id_stg_north_l = myidy
+       ELSE
+          id_stg_north_l = 0
+       ENDIF
+
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( id_stg_left_l, id_stg_left,   1, MPI_INTEGER,       &
+                           MPI_SUM, comm1dx, ierr )
+
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( id_stg_right_l, id_stg_right, 1, MPI_INTEGER,       &
+                           MPI_SUM, comm1dx, ierr )
+
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( id_stg_south_l, id_stg_south, 1, MPI_INTEGER,       &
+                           MPI_SUM, comm1dy, ierr )
+
+       IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
+       CALL MPI_ALLREDUCE( id_stg_north_l, id_stg_north, 1, MPI_INTEGER,       &
+                           MPI_SUM, comm1dy, ierr )
+
+    ENDIF 
+ 
 !
 !-- Broadcast the id of the inflow PE
Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 2938)
@@ -25,4 +25,9 @@
 ! -----------------
 ! $Id$
+! Initialization of soil moisture and temperature via Inifor-provided data also
+! in nested child domains, even if no dynamic input file is available for 
+! child domain. 1D soil profiles are received from parent model.  
+! 
+! 2936 2018-03-27 14:49:27Z suehring
 ! renamed lsm_par to land_surface_parameters. Bugfix in message calls
 ! 
@@ -2365,6 +2370,14 @@
        USE control_parameters,                                                 &
            ONLY:  message_string
+
+       USE indices,                                                            &
+           ONLY:  nx, ny
+
+       USE pmc_interface,                                                      &
+           ONLY:  nested_run
     
        IMPLICIT NONE
+
+       LOGICAL      ::  init_soil_dynamically_in_child !< flag controlling initialization of soil in child domains
 
        INTEGER(iwp) ::  i                       !< running index
@@ -2384,4 +2397,5 @@
 
        REAL(wp), DIMENSION(:), ALLOCATABLE ::  bound, bound_root_fr  !< temporary arrays for storing index bounds
+       REAL(wp), DIMENSION(:), ALLOCATABLE ::  pr_soil_init !< temporary array used for averaging soil profiles
 
 !
@@ -3894,4 +3908,19 @@
        IF (  TRIM( initializing_actions ) /= 'read_restart_data' )  THEN
 !
+!--       In case of nested runs, check if soil is initialized via dynamic
+!--       input file in root domain and distribute this information
+!--       to all embedded child domains. This case, soil moisture and
+!--       temperature will be initialized via root domain.  
+          init_soil_dynamically_in_child = .FALSE. 
+          IF ( nested_run )  THEN
+#if defined( __parallel )
+             CALL MPI_ALLREDUCE( init_3d%from_file_tsoil  .OR.                 &
+                                 init_3d%from_file_msoil,                      &
+                                 init_soil_dynamically_in_child,               &
+                                 1, MPI_LOGICAL, MPI_LOR, MPI_COMM_WORLD, ierr )
+#endif
+          ENDIF
+
+!
 !--       First, initialize soil temperature and moisture. 
 !--       According to the initialization for surface and soil parameters, 
@@ -3923,10 +3952,97 @@
           ENDDO
 !
-!--       Level 2, if soil moisture and/or temperature  are 
-!--       provided from file, interpolate / extrapolate the provided data
-!--       onto the respective soil layers. Please note, both, zs as well as 
-!--       init_3d%z_soil indicate a depth with positive values, so that no 
-!--       distinction between atmosphere is required concerning interpolation.
-!--       Start with soil moisture
+!--       Initialization of soil moisture and temperature from file. 
+!--       In case of nested runs, only root parent reads dynamic input file. 
+!--       This case, transfer respective soil information provide
+!--       by dynamic input file from root parent domain onto all other domains.
+          IF ( init_soil_dynamically_in_child )  THEN
+!
+!--          Child domains will be only initialized with horizontally 
+!--          averaged soil profiles in parent domain (for sake of simplicity). 
+!--          If required, average soil data on root parent domain before 
+!--          distribute onto child domains.
+             IF ( init_3d%from_file_msoil  .AND.  init_3d%lod_msoil == 2 )     &
+             THEN
+                ALLOCATE( pr_soil_init(0:init_3d%nzs-1) )
+
+                DO  k = 0, init_3d%nzs-1
+                   pr_soil_init(k) = SUM( init_3d%msoil(k,nys:nyn,nxl:nxr)  )
+                ENDDO
+!
+!--             Allocate 1D array for soil-moisture profile (will not be 
+!--             allocated in lod==2 case). 
+                ALLOCATE( init_3d%msoil_init(0:init_3d%nzs-1) )
+                init_3d%msoil_init = 0.0_wp
+#if defined( __parallel )
+                CALL MPI_ALLREDUCE( pr_soil_init(0), init_3d%msoil_init(0),    &
+                                    SIZE(pr_soil_init),                        &
+                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+#endif
+                init_3d%msoil_init = init_3d%msoil_init /                      &
+                                        REAL( ( nx + 1 ) * ( ny + 1), KIND=wp )
+                DEALLOCATE( pr_soil_init )
+             ENDIF
+             IF ( init_3d%from_file_tsoil  .AND.  init_3d%lod_tsoil == 2 )  THEN
+                ALLOCATE( pr_soil_init(0:init_3d%nzs-1) )
+
+                DO  k = 0, init_3d%nzs-1
+                   pr_soil_init(k) = SUM( init_3d%tsoil(k,nys:nyn,nxl:nxr)  )
+                ENDDO
+!
+!--             Allocate 1D array for soil-temperature profile (will not be 
+!--             allocated in lod==2 case). 
+                ALLOCATE( init_3d%tsoil_init(0:init_3d%nzs-1) )
+                init_3d%tsoil_init = 0.0_wp
+#if defined( __parallel )
+                CALL MPI_ALLREDUCE( pr_soil_init(0), init_3d%tsoil_init(0),    &
+                                    SIZE(pr_soil_init),                        &
+                                    MPI_REAL, MPI_SUM, comm2d, ierr )
+#endif
+                init_3d%tsoil_init = init_3d%tsoil_init /                      &
+                                        REAL( ( nx + 1 ) * ( ny + 1), KIND=wp )
+                DEALLOCATE( pr_soil_init )
+
+             ENDIF
+
+#if defined( __parallel )
+!
+!--          Distribute soil grid information on file from root to all childs.
+!--          Only process with rank 0 sends the information. 
+             CALL MPI_BCAST( init_3d%nzs,    1,                                &
+                             MPI_INTEGER, 0, MPI_COMM_WORLD, ierr )
+
+             IF ( .NOT.  ALLOCATED( init_3d%z_soil ) )                         &
+                ALLOCATE( init_3d%z_soil(1:init_3d%nzs) )
+
+             CALL MPI_BCAST( init_3d%z_soil, SIZE(init_3d%z_soil),             &
+                             MPI_REAL, 0, MPI_COMM_WORLD, ierr )
+#endif
+!
+!--          ALLOCATE arrays on child domains and set control attributes.
+             IF ( .NOT. init_3d%from_file_msoil )  THEN
+                ALLOCATE( init_3d%msoil_init(0:init_3d%nzs-1) )
+                init_3d%lod_msoil = 1
+                init_3d%from_file_msoil = .TRUE.
+             ENDIF
+             IF ( .NOT. init_3d%from_file_tsoil )  THEN
+                ALLOCATE( init_3d%tsoil_init(0:init_3d%nzs-1) )
+                init_3d%lod_tsoil = 1
+                init_3d%from_file_tsoil = .TRUE.
+             ENDIF
+
+
+#if defined( __parallel )
+!
+!--          Distribute soil profiles from root to all childs
+             CALL MPI_BCAST( init_3d%msoil_init, SIZE(init_3d%msoil_init),     &
+                             MPI_REAL, 0, MPI_COMM_WORLD, ierr )
+             CALL MPI_BCAST( init_3d%tsoil_init, SIZE(init_3d%tsoil_init),     &
+                             MPI_REAL, 0, MPI_COMM_WORLD, ierr )
+#endif
+
+          ENDIF
+!
+!--       Proceed with Level 2 initialization. Information from dynamic input
+!--       is now available on all processes. 
           IF ( init_3d%from_file_msoil )  THEN
 
@@ -3983,5 +4099,4 @@
                 ENDDO
              ENDIF
-
           ENDIF
 !
Index: palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90
===================================================================
--- palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2934)
+++ palm/trunk/SOURCE/large_scale_forcing_nudging_mod.f90	(revision 2938)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Further improvements for nesting in larger-scale model
+! 
+! 2863 2018-03-08 11:36:25Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -210,5 +213,5 @@
        ENDIF
 !
-!--       Top boundary
+!--    Top boundary
        k = nzt
        DO  i = nxl, nxr
@@ -235,4 +238,7 @@
           ENDDO
        ENDDO
+
+write(9,*) "w correction", w_correct
+flush(9)
 
     END SUBROUTINE forcing_bc_mass_conservation
@@ -581,50 +587,91 @@
 !--    identical to the Inifor grid. At the top boundary an extrapolation is 
 !--    not possible. 
-       IF ( ANY( zu(1:nzt+1) /= force%zu_atmos(1:force%nzu) ) )  THEN
-          DO  i = nxlu, nxr
-             DO  j = nys, nyn
-                u(nzt+1,j,i) = force%u_top(0,j,i) + ddt_lsf * t_ref *          &
-                           ( force%u_top(1,j,i) - force%u_top(0,j,i) ) *       &
-                              MERGE( 1.0_wp, 0.0_wp,                           &
-                                     BTEST( wall_flags_0(nzt+1,j,i), 1 ) )
-             ENDDO
-          ENDDO
-
-          DO  i = nxl, nxr
-             DO  j = nysv, nyn
-                v(nzt+1,j,i) = force%v_top(0,j,i) + ddt_lsf * t_ref *          &
-                           ( force%v_top(1,j,i) - force%v_top(0,j,i) ) *       &
-                              MERGE( 1.0_wp, 0.0_wp,                           &
-                                     BTEST( wall_flags_0(nzt+1,j,i), 2 ) )
-             ENDDO
-          ENDDO
-
+       DO  i = nxlu, nxr
+          DO  j = nys, nyn
+             u(nzt+1,j,i) = force%u_top(0,j,i) + ddt_lsf * t_ref *             &
+                        ( force%u_top(1,j,i) - force%u_top(0,j,i) ) *          &
+                           MERGE( 1.0_wp, 0.0_wp,                             &
+                                  BTEST( wall_flags_0(nzt+1,j,i), 1 ) )
+          ENDDO
+       ENDDO
+
+       DO  i = nxl, nxr
+          DO  j = nysv, nyn
+             v(nzt+1,j,i) = force%v_top(0,j,i) + ddt_lsf * t_ref *             &
+                        ( force%v_top(1,j,i) - force%v_top(0,j,i) ) *          &
+                           MERGE( 1.0_wp, 0.0_wp,                              &
+                                  BTEST( wall_flags_0(nzt+1,j,i), 2 ) )
+          ENDDO
+       ENDDO
+
+       DO  i = nxl, nxr
+          DO  j = nys, nyn
+             w(nzt:nzt+1,j,i) = force%w_top(0,j,i) + ddt_lsf * t_ref *         &
+                        ( force%w_top(1,j,i) - force%w_top(0,j,i) ) *          &
+                           MERGE( 1.0_wp, 0.0_wp,                              &
+                                  BTEST( wall_flags_0(nzt:nzt+1,j,i), 3 ) )
+          ENDDO
+       ENDDO
+
+
+       IF ( .NOT. neutral )  THEN
           DO  i = nxl, nxr
              DO  j = nys, nyn
-                w(nzt:nzt+1,j,i) = force%w_top(0,j,i) + ddt_lsf * t_ref *      &
-                           ( force%w_top(1,j,i) - force%w_top(0,j,i) ) *       &
-                              MERGE( 1.0_wp, 0.0_wp,                           &
-                                     BTEST( wall_flags_0(nzt:nzt+1,j,i), 3 ) )
-             ENDDO
-          ENDDO
-
-
-          IF ( .NOT. neutral )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   pt(nzt+1,j,i) = force%pt_top(0,j,i) + ddt_lsf * t_ref *     &
-                           ( force%pt_top(1,j,i) - force%pt_top(0,j,i) )
-                ENDDO
-             ENDDO
-          ENDIF
-
-          IF ( humidity )  THEN
-             DO  i = nxl, nxr
-                DO  j = nys, nyn
-                   q(nzt+1,j,i) = force%q_top(0,j,i) + ddt_lsf * t_ref *       &
-                           ( force%q_top(1,j,i) - force%q_top(0,j,i) )
-                ENDDO
-             ENDDO
-          ENDIF
+                pt(nzt+1,j,i) = force%pt_top(0,j,i) + ddt_lsf * t_ref *        &
+                        ( force%pt_top(1,j,i) - force%pt_top(0,j,i) )
+             ENDDO
+          ENDDO
+       ENDIF
+
+       IF ( humidity )  THEN
+          DO  i = nxl, nxr
+             DO  j = nys, nyn
+                q(nzt+1,j,i) = force%q_top(0,j,i) + ddt_lsf * t_ref *          &
+                        ( force%q_top(1,j,i) - force%q_top(0,j,i) )
+             ENDDO
+          ENDDO
+       ENDIF
+!
+!--    At the edges( left-south, left-north, right-south and right-north) set 
+!--    data on ghost points. 
+       IF ( force_bound_l  .AND.  force_bound_s )  THEN
+          DO  i = 1, nbgp
+             u(:,nys-i,nxlg:nxl)   = u(:,nys,nxlg:nxl)
+             w(:,nys-i,nxlg:nxl-1) = w(:,nys,nxlg:nxl-1)
+             IF ( .NOT. neutral )  pt(:,nys-i,nxlg:nxl-1) = pt(:,nys,nxlg:nxl-1)
+             IF ( humidity )       q(:,nys-i,nxlg:nxl-1)  = q(:,nys,nxlg:nxl-1)
+          ENDDO
+          DO  i = 1, nbgp+1
+             v(:,nysv-i,nxlg:nxl-1) = v(:,nysv,nxlg:nxl-1)
+          ENDDO
+       ENDIF
+       IF ( force_bound_l  .AND.  force_bound_n )  THEN
+          DO  i = 1, nbgp
+             u(:,nyn+i,nxlg:nxl)   = u(:,nyn,nxlg:nxl)
+             v(:,nyn+i,nxlg:nxl-1) = v(:,nyn,nxlg:nxl-1)
+             w(:,nyn+i,nxlg:nxl-1) = w(:,nyn,nxlg:nxl-1)
+             IF ( .NOT. neutral )  pt(:,nyn+i,nxlg:nxl-1) = pt(:,nyn,nxlg:nxl-1)
+             IF ( humidity )       q(:,nyn+i,nxlg:nxl-1)  = q(:,nyn,nxlg:nxl-1)
+          ENDDO
+       ENDIF
+       IF ( force_bound_r  .AND.  force_bound_s )  THEN
+          DO  i = 1, nbgp
+             u(:,nys-i,nxr+1:nxrg) = u(:,nys,nxr+1:nxrg)
+             w(:,nys-i,nxr+1:nxrg) = w(:,nys,nxr+1:nxrg)
+             IF ( .NOT. neutral )  pt(:,nys-i,nxr+1:nxrg) = pt(:,nys,nxr+1:nxrg)
+             IF ( humidity )       q(:,nys-i,nxr+1:nxrg)  = q(:,nys,nxr+1:nxrg)
+          ENDDO
+          DO  i = 1, nbgp+1
+             v(:,nysv-i,nxr+1:nxrg) = v(:,nysv,nxr+1:nxrg)
+          ENDDO
+       ENDIF
+       IF ( force_bound_r  .AND.  force_bound_n )  THEN
+          DO  i = 1, nbgp
+             u(:,nyn+i,nxr+1:nxrg) = u(:,nyn,nxr+1:nxrg)
+             v(:,nyn+i,nxr+1:nxrg) = v(:,nyn,nxr+1:nxrg)
+             w(:,nyn+i,nxr+1:nxrg) = w(:,nyn,nxr+1:nxrg)
+             IF ( .NOT. neutral )  pt(:,nyn+i,nxr+1:nxrg) = pt(:,nyn,nxr+1:nxrg)
+             IF ( humidity )       q(:,nyn+i,nxr+1:nxrg)  = q(:,nyn,nxr+1:nxrg)
+          ENDDO
        ENDIF
 !
@@ -941,4 +988,7 @@
     SUBROUTINE lsf_init
 
+       USE control_parameters,                                                 &
+           ONLY:  bc_lr_cyc, bc_ns_cyc
+
        USE netcdf_data_input_mod,                                              &
            ONLY:  netcdf_data_input_lsf  
@@ -975,4 +1025,13 @@
 
        IF ( forcing )  THEN
+!
+!--       Allocate arrays for geostrophic wind components. Arrays will 
+!--       incorporate 2 time levels in order to interpolate in between. Please
+!--       note, forcing using geostrophic wind components is only required in 
+!--       case of cyclic boundary conditions.
+          IF ( bc_lr_cyc  .AND.  bc_ns_cyc )  THEN
+             ALLOCATE( force%ug(0:1,nzb:nzt+1) )
+             ALLOCATE( force%vg(0:1,nzb:nzt+1) )
+          ENDIF
 !
 !--       Allocate arrays for reading boundary values. Arrays will incorporate 2 
